var defaultFilters = [];
var linkForEditFormatterLogsTable = function(data){ return linkForEditFormatter(data, "logsTable", "syslogServerAction");};
var linkForEditFormatterDevicesTable = function(data){ return linkForEditFormatter(data, "devicesTable", "netDevListAction");};
var linkForEditFormatterServersTable = function(data){ return linkForEditFormatter(data, "detailTableId", "activeDirectoryServerAction");};
var linkForEditFormatterAdminsTable = function(data){ return linkForEditFormatter(data, "administratorsTable", "adminAction");};

var linkForEditFormatter = function(data, tableObj, actionFunction)
{
  return '<a href="javascript:;" onClick="javascript: ' + tableObj + '.clearSelections(); ' + tableObj + '.selectByIndex(' + tableObj + '._idToIndex[\'' + data + '\']); ' + actionFunction + '(\'edit\');">' + data + '</a>';
};

//servers
var statusFormatter = function(data) {
    var image;
    if (data == "down")
        image = 'alert_stopped_n_16.png';
    else if (data == "up")
        image = 'alert_normal_n_16.png';
    else if (data == "progress")
    {
        image = 'alert_in_progress_n_16.png';
        data = "connecting";
    }
    else
    {
        image = 'alert_unknown_n_16.png';
        data = "unknown";
    }

    return '<img title="' + data + '" src="img/' + image + '" border="0" width="14px"/>';
};

var versionFormatterServersTable = function(data) {
    if (data == "Win2003" || data == "Win2003R2" || data == "Win2008" || data == "Win2008R2" || data == "Win2012")
        return data;
    else
        return '<span class="versionUnsupported">' + data + '</span>';
};

var serversTableStructure = [
{
    attr: "status",
    label: "Status",
    width: 50,
    alignment: "center",
    formatter : statusFormatter,
    sortable: false,
    editable: false,
    filterable: false
}, {
    attr: "name",
    label: "Name",
    width: 70,
    editable: false,
    sortable: true,
    sorted: "ascending",
    filterable: false,
    formatter: linkForEditFormatterServersTable
}, {
    attr: "host",
    label: "Host/IP",
    width: 70,
    editable: false,
    sortable: true,
    filterable: false
}, {
    attr: "domainNetBIOS",
    label: "Domain",
    width: 50,
    editable: false,
    sortable: true,
    filterable: false
}, {
    attr: "username",
    label: "Admin",
    hidden: true,
    editable: false,
    filterable: false
}, {
    attr: "version",
    label: "Version",
    width: 50,
    editable: false,
    filterable: false,
    formatter: versionFormatterServersTable
},{
    attr: "password",
    label: "Password",
    hidden: true,
    editable: false,
    filterable: false
}];

var domainsTableStructure = [
{
    attr: "status",
    label: "Status",
    width: 50,
    alignment: "center",
    formatter : statusFormatter,
    sortable: false,
    editable: false,
    filterable: false
}, {
    attr: "name",
    label: "Name",
    hidden: true,
    editable: false,
    filterable: true
}, {
    attr: "host",
    label: "Host/IP",
    hidden: true,
    editable: false,
    filterable: false
}, {
    attr: "domain",
    label: "Domain FQDN",
    width: 220,
    editable: false,
    sortable: true,
    filterable: true
}, {
    attr: "username",
    label: "Admin",
    hidden: true,
    editable: false,
    filterable: false
}, {
    attr: "password",
    label: "Password",
    hidden: true,
    editable: false,
    filterable: false
}];

//devices
var statusDevicesFormatter = function(data) {
    var image;
    if (data == "out-of-sync")
        image = 'state_synced_no_n_16.png';
    else if (data == "in-sync")
        image = 'state_synced_yes_n_16.png';
    else
    {
        image = 'alert_unknown_n_16.png';
        data = "unknown";
    }

    return '<img title="' + data + '" src="img/' + image + '" border="0" width="14px"/>';
};

var gridStructure = [
{
    label: "Name",
    attr: "name",
    sortable: true,
    sorted: "ascending",
    width: 150,
    vAlignment: "middle",
    alignment: "left",
    filterable: true,
    filterType: "string",
    editable: false,
    locked:false,
    formatter: linkForEditFormatterDevicesTable
},{
    label: "IP Address",
    attr: "ip",
    sortable: true,
    width: 120,
    vAlignment: "middle",
    alignment: "left",
    filterable: true,
    editable: false,
    filterType: "string"
},
{
    label: "Mask",
    attr: "mask",
    sortable: true,
    width: 50,
    vAlignment: "middle",
    alignment: "left",
    filterable: true,
    editable: false,
    filterType: "string"
},
{
    label: "rowIndex",
    attr: "rowIndex",
    hidden: true,
    filterable: false
},
{
    label: "sharedSecret",
    attr: "secret",
    hidden: true,
    filterable: false
}
];

//syslogs
var logsTableStructure = [
{
    attr: "name",
    label: "Name",
    width: "120",
    sortable: true,
    sorted: "ascending",
    editable: false,
    filterable: true,
    formatter: linkForEditFormatterLogsTable
}, {
    attr: "logIp",
    label: "IP Address",
    width: "90",
    editable: false,
    sortable: true,
    filterable: true
}, {
    attr: "facility",
    label: "Facility",
    width: "90",
    sortable: true,
    editable: false,
    filterable: true
}];

//mapping filters
var mappingFiltersTableStructure = [
{
    attr: "name",
    label: "Name",
    hidden: true,
    filterable: false
}, {
    attr: "usernameRegexp",
    label: "Username",
    width: "180",
    sortable: true,
    vAlignment: "middle",
    alignment: "left",
    editable: false,
    filterable: true
}, {
    attr: "ipRegexp",
    label: "IP Address",
    width: "180",
    editable: false,
    sortable: true,
    vAlignment: "middle",
    alignment: "left",
    filterable: true
}, {
    attr: "applyOnExisting",
    label: "applyOnExisting",
    editable: false,
    hidden: true,
    filterable: false
}];

var convertToUpper = function() {
    return arguments[0].toUpperCase();
};

var authorityFormatterAdminsTable = function(data)
{
    if (typeof data != undefined && data != null)
    {
        //data = JSON.stringify(data);
        data = data.replace(/ROLE_/g, "");
        return data.toLowerCase().replace(/\b[a-z]/g, convertToUpper);
    }
    else
        return data;
};

var administratorsTableStructure = [
{
    attr: "username",
    label: "Username",
    width: "140",
    alignment: "left",
    editable: false,
    sortable: true,
    filterable: true,
    formatter: linkForEditFormatterAdminsTable
},
{
    attr: "firstname",
    label: "First Name",
    width: "140",
    alignment: "left",
    editable: false,
    filterable: true,
    sortable: true
}, {
    attr: "lastname",
    label: "Last Name",
    width: "140",
    alignment: "left",
    editable: false,
    filterable: true,
    sortable: true
}, {
    attr: "authority",
    label: "Admin Access",
    width: "200",
    alignment: "left",
    editable: false,
    sortable: true,
    filterable: true,
    formatter: authorityFormatterAdminsTable
}];

var consumerDevicesStructure = [
{
    label: "Status",
    attr: "status",
    sortable: true,
    width: 120,
    vAlignment: "middle",
    formatter : statusDevicesFormatter,
    alignment: "center",
    editable: false,
    filterable: true,
    filterType: 'enumeration',
    filterOptions: {
        autoSuggestValues: [ "out-of-sync", "in-sync"],
        sortAutoSuggestValues: false,
        autoSuggestDelay: 200
    }
},{
    label: "IP Address",
    attr: "ip",
    sortable: true,
    width: 200,
    vAlignment: "middle",
    alignment: "left",
    filterable: true,
    editable: false,
    filterType: "string"
},{
    label: "Configuration name",
    attr: "name",
    sortable: true,
    sorted: true,
    width: 300,
    vAlignment: "middle",
    alignment: "left",
    filterable: true,
    filterType: "string",
    editable: false
},{
    label: "Configuration range",
    attr: "range",
    sortable: true,
    width: 200,
    vAlignment: "middle",
    alignment: "left",
    filterable: true,
    filterType: "string",
    editable: false
}];


var detailWidgetString =
   "<div style='width: 310px; height:120px;margin: 2px 2px 2px 40px; border: 1px solid #8499a2; position:relative; display:none; overflow:auto;'>" +
     "<div  dojoType='dijit.layout.BorderContainer' liveSplitters='false' style='width: 95%; height: 90%; float: left; margin: 0;'>" +
        "<div dojoType='dijit.layout.ContentPane' dojoAttachPoint='tableContentPane' region='center' style='width: 100%; height: 100%; float: left; margin: 0;'>" +
            "<div style='display: none;' id='group_id' jsId='group_id' dojoAttachPoint='group_id' value='' name='group_id' dojoType='dijit.form.TextBox'></div>" +
            "<table id='detailTableId' jsId='detailTableId' dojoType='xwt.widget.table.Table' style='overflow:hidden;' dojoAttachPoint='svrTable' store='svrStore' structure='detailStructure' immediateCommit='false'></table>" +
         "</div>" +
     "</div>" +
   "</div>";

var isEmptyObject = function(obj){
    for(var prop in obj)
    {
        if(obj.hasOwnProperty(prop))
            return false;
    }
    return true;
};

var attributesFormatter = function(data) {
/*    var objAsString = JSON.stringify(data);
    if (objAsString != undefined && objAsString.length > 2)
    {
        return objAsString;
    }
    else
      return "none";*/
    if (isEmptyObject(data))
        return "";
    else
        return '<div class="cell-expander eye-cell" title="Expand"></div>';
};

var timestampFormatter = function(data) {
    if (data != undefined)
    {
       var splitted = data.split(" ");
       if (splitted.length > 0)
        return splitted[0].replace("T", " ");
    }
    else
        return data;
};
var sequenceFormatter = function(data) {
    if (data != undefined)
    {
       var splitted = data.split(" ");
       if (splitted.length > 1)
        return parseInt(splitted[1]);
    }
    else
        return data;
};

var severityFormatter = function(data) {
    var image = 'alert_informational_n_16.png'; //NOTICE

    if (data == "WARN") {
        image = 'alert_minor_n_16.png';
    } else if (data == "ERROR") {
        image = 'reject_1055_16.png'; //'alert_major_2001_16.png';
    } else if (data == "FATAL") {
        image = 'alert_critical_n_16.png';
    } else if (data == "INFO") {
        image = 'alert_warning_2003_16.png';
    } else if (data == "DEBUG") {
        image = 'configure_n_16.png';
    }

    return '<img title="' + data + '" src="img/' + image + '"/>';
};

