<%@ page import="com.cisco.cda.mgmt.item.ItemBase" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<!--**************************************************-->
<!-- Copyright (c) 2009-2012 Cisco Systems, Inc.-->
<!-- All rights reserved.-->
<!--**************************************************-->
<%@ page session="true" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<html>
    <head>
        <jsp:include page="../scriptSources.jsp"/>
        <script type="text/javascript" src="${pageContext.request.contextPath}/lib/utils/passwordPolicy.js"></script>
        <script type="text/javascript">

            function prepopulatePolicy()
            {
                dojo.xhrGet({
                    url: "adminsAction.do?command=getpolicy",
                    handleAs: "json",
                    preventCache: true,
                    load: function(data) {
                        dojo.byId("passwordPolicySpan").innerHTML = passwordPolicyStringBuilder(data); 
                    },
                    error: function(error) {
                        showErrorMessage("An error occured on server " + error);
                    }
                });
            }

            function initAdministratorsPage()
        	{
				dojo.connect(administratorsTable, "onSelect", function(){
					adminActionChangeButtonState();
				});
				dojo.connect(administratorsTable, "onDeselect", function(){
					adminActionChangeButtonState();
				});
				dojo.connect(administratorsTable, "onLoadEnd", function(){
					adminActionMenus();
				});

				dojo.connect(adminActionEdit, "onClick", function(event){
					dojo.stopEvent(event);
                    prepopulatePolicy();
					adminAction('edit');
					refreshAdministratorsTable();
				});

				dojo.connect(adminActionAdd, "onClick", function(event){
					dojo.stopEvent(event);
					prepopulatePolicy();
                    adminAction('add');
					refreshAdministratorsTable();
				});

				dojo.connect(adminActionDelete, "onClick", function(event){
					dojo.stopEvent(event);
					adminAction('delete');
				});

                adminForm.additionalValidation = function () {
                    var pw1 = dijit.byId("adminUser.password");
                    var pw2 = dijit.byId("vpassword");
                    if ((pw1.value.length > 0) && (pw1.value === pw2.value))
                        return true;
                    else
                    {
                        dijit.byId("vpassword").setValue("");
                        return false;
                    }
                };

                dojo.connect(dijit.byId("administratorsTable_xwtTableGlobalToolbar_refreshButton"), "onClick", function(){
                    refreshAdministratorsTable();
                });

                sendForm("adminForm", "adminDialog", "administratorsTable");
        	}

            initOnLoad(initAdministratorsPage, "com_cisco_xmp_web_view_administratorsTable");

            var refreshAdministratorsTable = function()
            {
                if (typeof administratorsTable != "undefined" && administratorsTable != null)
                {
                    administratorsTable.store.close();
                    administratorsTable.refresh();
                }
            };

            var adminAction = function (btnId) {

            	if (btnId == "add")
            	{
            		dojo.query("#adminForm #adminToEdit").attr("value", "");
            		dojo.query("#adminForm input[id='adminUser.username']").attr("value", "");
            		dojo.query("#adminForm input[id='adminUser.password']").attr("value", "");
                    dojo.query("#adminForm input[id='vpassword']").attr("value", "");
            		dojo.query("#adminForm input[id='adminUser.firstname']").attr("value", "");
            		dojo.query("#adminForm input[id='adminUser.lastname']").attr("value", "");
                    dijit.byId("adminUser.authority").attr("value", "");

            		showDialog('adminDialog');
			showDialogAddContextHelp("adminDialog", "admin");
            	}

            	var selectedArr = administratorsTable.selected();
                var selectionCount = selectedArr.length;

                if (selectionCount == 0 && (btnId == "edit" || btnId == "delete"))
            		return false;


            	if(btnId == "edit" && selectionCount>0) {
            		var item = selectedArr[0];
                    dojo.query("#adminForm #adminToEdit").attr("value", item.username);
            		dojo.query("#adminForm input[id='adminUser.username']").attr("value", item.username);
            		dojo.query("#adminForm input[id='adminUser.password']").attr("value", "");
                    dojo.query("#adminForm input[id='vpassword']").attr("value", "");
            		dojo.query("#adminForm input[id='adminUser.firstname']").attr("value", item.firstname);
            		dojo.query("#adminForm input[id='adminUser.lastname']").attr("value", item.lastname);

                    var auth = item.authority[0].split(",");
                    var authToEdit;
                    if (auth.length > 1)
                        authToEdit = auth[1].trim();
                    else
                        authToEdit = auth[0].trim();

                    dijit.byId("adminUser.authority").attr("value", authToEdit);

            		showDialog('adminDialog');
			showDialogAddContextHelp("adminDialog", "admin");
            	}

            	if(btnId == "delete")
            		deleteItems(administratorsTable, "adminToEdit", "adminsAction.do?command=delete", selectedArr);

            	administratorsTable.clearSelections();

            	return true;
            };

    		function adminActionChangeButtonState()
    		{
    			var s = administratorsTable.selected();

    			if(!s.length){
    				adminActionEdit.attr("disabled", true);
    				adminActionDelete.attr("disabled", true);
    			} else if(s.length == 1){
    				adminActionEdit.attr("disabled", false);
    				adminActionDelete.attr("disabled", false);
    			} else {
    				adminActionEdit.attr("disabled", true);
    				adminActionDelete.attr("disabled", false);
    			}
    		}

    		var adminActionMenus = function() {
    			adminActionAdd.setDisabled(false);
                if (administratorsTable._totalRows == 0) {
    				adminActionDelete.attr("disabled", true);
    			}
    		};
		</script>
    </head>
    <body class="reboot2 xwtNotification">
    	<div dojotype="dijit.layout.BorderContainer" gutters="false" class="dashboardBorderContainer">
    	
	    	<div dojoType="dijit.layout.ContentPane" class="dashboardContentPane">
	    	
			<span dojoType="dojo.data.ItemFileWriteStore" jsId="administratorsStore" url="adminsAction.do?command=list" clearOnClose="true" urlPreventCache="true"></span>

                <div id="administratorsGlobalToolbar" dojoType="xwt.widget.table.GlobalToolbar" title="Administrators" tableId="administratorsTable" showButtons="refresh" displayTotalRecords="true"></div>
                <div id="administratorsContextToolbar" jsId="contextToolbar" dojoType="xwt.widget.table.ContextualToolbar" tableId="administratorsTable" needFilter="true">
                    <button type="submit" id="adminActionEdit" jsId="adminActionEdit" disabled="true"  showLabel="true" iconClass="xwtContextualIcon xwtContextualEdit" dojoType="dijit.form.Button" label="Edit">Edit</button>
                    <button type="submit" id="adminActionAdd" jsId="adminActionAdd" showLabel="true" iconClass="xwtContextualIcon xwtContextualAddRow" disabled="false" dojoType="dijit.form.Button" label="Add">Add</button>
                    <div class="dijitToolbarSeparator dijitInline"></div>
                    <button type="submit" id="adminActionDelete" jsId="adminActionDelete" showLabel="true" disabled="true" iconClass="xwtContextualIcon xwtContextualDelete" dojoType="dijit.form.Button" label="Delete">Delete</button>
                 </div>
                 <div id="administratorsTable" jsId="administratorsTable" dojoType="xwt.widget.table.Table" store="administratorsStore"
                     query="''" queryOptions="{ignoreCase:true}" structure="administratorsTableStructure" selectMultiple="true" selectModel="input"
                     filterDelay="500" immediateCommit="false" filters="defaultFilters">
                 </div>
            </div>
        </div>

    <div class="hideit">


		<div dojoType="xwt.widget.layout.Dialog" title="Administrator Form" class="xwtNotification" id="adminDialog" bgColor="black" bgOpacity="0.5" toggle="fade" toggleDuration="100" closeNode="hider">
			<form name="adminForm" action="adminsAction.do?command=save" method="post" dojoAttachPoint="adminForm" jsId="adminForm" id="adminForm" dojoType="xwt.widget.notification.Form">
		        <input type="hidden" name="adminToEdit" id="adminToEdit" value=""/>
		        <table>
					<tr>
						<td class="tdleft">
							<label for="adminUser.username"><span class="labelRequired">*</span>Username</label>
						</td>
						<td class="tdright">
							<input id="adminUser.username" name="adminUser.username" type="text" tooltipPosition="top" trim="true"  dojoType="xwt.widget.notification.ValidationTextBox" required="true" maxLength="<%=ItemBase.MAX_ITEM_MEMBER_LENGTH%>"/>
						</td>
					</tr>
					<tr>
						<td class="tdleft">
							<label for="adminUser.password"><span class="labelRequired">*</span>Password</label>
						</td>
						<td class="tdright">
							<input id="adminUser.password" name="adminUser.password" type="password" tooltipPosition="top" trim="true"  dojoType="xwt.widget.notification.ValidationTextBox" required="true" maxLength="<%=ItemBase.MAX_ITEM_MEMBER_LENGTH%>"/>
						</td>
					</tr>
					<tr>
                        <td class="tdleft">
							<label for="vpassword"><span class="labelRequired">*</span>Verify password</label>
						</td>
						<td class="tdright">
							<input id="vpassword" name="vpassword" tooltipPosition="top" type="password"  trim="true"  dojoType="xwt.widget.notification.ValidationTextBox" required="true" maxLength="<%=ItemBase.MAX_ITEM_MEMBER_LENGTH%>"/>
						</td>
					</tr>
					<tr>
						<td class="tdleft">
							<label for="adminUser.authority">Authority</label>
						</td>
						<td class="tdright">
					        <select name="adminUser.authority" id="adminUser.authority" dojoType="dijit.form.Select" style="width: 12em;">
					            <option value="ROLE_USER" selected="selected">User</option>
                                <option value="ROLE_ADMIN">Admin</option>
				       		</select>
						</td>
					</tr>                    
		        	<tr>
		        		<td colspan="2" class="tdPaddingVertical">Personal Information</td>
					</tr>
					<tr>
						<td class="tdleft">
							<label for="adminUser.firstname">First Name</label>
						</td>
						<td class="tdright">
							<input id="adminUser.firstname" name="adminUser.firstname" type="text" tooltipPosition="top" trim="true"  dojoType="xwt.widget.notification.ValidationTextBox" maxLength="<%=ItemBase.MAX_ITEM_MEMBER_LENGTH%>"/>
						</td>
					</tr>
					<tr>
                        <td class="tdleft">
							<label for="adminUser.lastname">Last Name</label>
						</td>
						<td class="tdright">
							<input id="adminUser.lastname" name="adminUser.lastname" type="text" tooltipPosition="top" trim="true"  dojoType="xwt.widget.notification.ValidationTextBox" maxLength="<%=ItemBase.MAX_ITEM_MEMBER_LENGTH%>"/>
						</td>
					</tr>
					<tr>
                        <td colspan="2" style="font-size: 10px; padding-top:10px;">
                            <div style="width: 300px;"><b>Password policy</b>: <span id="passwordPolicySpan"></span></div>
                        </td>
					</tr>
					<tr>
						<td class="buttonstd" colspan="2">
	                        <button dojoType="xwt.widget.form.TextButton" class="xwtDisableableButton" type="submit" name="button" id="submit_button">
	                            Save
	                        </button>
	                        <button dojoType="xwt.widget.form.TextButton" type="button" onClick="dijit.byId('adminDialog').hide();">
	                            Cancel
	                        </button>
						</td>
					</tr>			
				</table>
			</form>
		</div>        
    </div>
    </body>
</html>
