<%@ page import="com.cisco.cda.mgmt.item.ItemBase" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<!--**************************************************-->
<!-- Copyright (c) 2009-2012 Cisco Systems, Inc.-->
<!-- All rights reserved.-->
<!--**************************************************-->
<%@ page session="true" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<html>
    <head>
        <jsp:include page="../scriptSources.jsp"/>
        <script type="text/javascript">

			var updateTimeout = 10;
            var adServerSubscribehandler;
            var devicesSubscribehandler;
            var syslogsSubscribehandler;

            var getAgentStatus = function() {
                var xhrArgs = {
                    url: "agentAction.do?command=hello",
                    handleAs: "json",
                    preventCache: true,
                    load: function(data) {
                        if (data.monitoring)
                        {
                            var agentFormHandle = dojo.byId("agentForm");
                            dojo.query("input[id='agentConfig.monitoring']", agentFormHandle).attr("value", data.monitoring);
                            dojo.query("input[id='agentConfig.history']", agentFormHandle).attr("value", data.history);
                            dojo.query("input[id='agentConfig.userLogonTtl']", agentFormHandle).attr("value", data.userLogonTtl);
                            dijit.byId("agentConfig.NTLMv2").attr("value", data.NTLMv2);
                            dijit.byId("agentConfig.level").attr("value", data.level);
                        }
                        else
                        {
                            showErrorMessage("Failed to load agent settings.");
                        }
                    },
                    error: function(error) {
                        showErrorMessage("An error occured on server " + error);
                    }
                };
                var deferred = dojo.xhrGet(xhrArgs);
            };

	       	var destroyOperationsPage = function()
            {
                dojo.unsubscribe(adServerSubscribehandler);
                adServerSubscribehandler = null;
                dojo.unsubscribe(devicesSubscribehandler);
                devicesSubscribehandler = null;
                dojo.unsubscribe(syslogsSubscribehandler);
                syslogsSubscribehandler = null;
            };
            
            var initOperationsPage = function()
	       	{
	       		adServerSubscribehandler = dojo.subscribe("AD_SERVERS_UPDATE", function(data){
	       			var items = data.size;
	       			if (items > -1)
       				{
   						dojo.byId("activeDirectoryServers").innerHTML = items + " Domain" + (items == 1? "":"s");
       				}
	       		});

	       		devicesSubscribehandler = dojo.subscribe("DEVICES_UPDATE", function(data){
	       			var items = data.size;
	       			if (items > -1)
       				{
	       				dojo.byId("consumerDevices").innerHTML = items + " Identity Consumer" + (items == 1? "":"s");
                        dojo.query("#com_cisco_xmp_web_view_operations .showOnPageLoad").forEach(function(node){
                		    if (dojo.hasClass(node, "hideit"))
                                dojo.removeClass(node, "hideit");
                	    });
       				}
	       		});

	       		syslogsSubscribehandler = dojo.subscribe("SYSLOGS_UPDATE", function(data){
	       			var items = data.size;
	       			if (items > -1)
       				{
	   					dojo.byId("syslogServers").innerHTML = items + " Syslog Server" + (items == 1? "":"s");
	    	   		}
	       		});

                dojo.connect(dijit.byId("agentForm"), "onSubmit", function(event) {
                   dojo.stopEvent(event);

                   if (!dijit.byId("agentForm").isValid())
                       return false;

                   if (dijit.byId("agentConfig.NTLMv2").checked)
                       dijit.byId("agentConfig.NTLMv2").setValue("true");

                   var xhrArgs = {
                       form: dojo.byId("agentForm"),
                       handleAs: "json",
                       load: function(data) {
                           if (data.status)
                               showSuccessMessage("Agent Configuration saved.");
                           else
                               showNotificationAlert("critical", data.message);
                       },
                       error: function(error) {
                           showErrorMessage("An error occured on server " + error);
                       },
                       handle: function(data, error) {
                           dijit.byId("agentDialog").hide();
                       }
                   };
                   dojo.xhrPost(xhrArgs);
               });

                dojo.connect(dijit.byId("globalForm"), "onSubmit", function(event) {
                   dojo.stopEvent(event);

                   if (!dijit.byId("globalForm").isValid())
                       return false;

                   var xhrArgs = {
                       form: dojo.byId("globalForm"),
                       handleAs: "json",
                       load: function(data) {
                           if (data.status)
                               showSuccessMessage("Global Log Level saved.");
                           else
                               showNotificationAlert("critical", data.message);
                       },
                       error: function(error) {
                           showErrorMessage("An error occured on server " + error);
                       },
                       handle: function(data, error) {
                           dijit.byId("globalDialog").hide();
                       }
                   };
                   dojo.xhrPost(xhrArgs);
               });

               sendForm("serverForm", "serverDialog", "serversTable");
               sendForm("consumerForm", "consumerDialog" , "devicesTable");
               sendForm("syslogForm", "syslogDialog", "logsTable");

               dojo.connect(
                   dojo.byId("com_cisco_xmp_web_view_operations_xwtTitlePaneTextNode"),
                   "onclick",
                   function()
                   {
                       dojo.byId("com_cisco_xmp_web_view_operations_collapseExpand").click();
                   }
               );
               dojo.connect(
                   dijit.byId("com_cisco_xmp_web_view_operations_collapseExpand"),
                   "onClick",
                   refreshAllDashboardTables
               );

               refreshAllDashboardTables();
	       	};

	       	initOnLoad(initOperationsPage, "com_cisco_xmp_web_view_operations");
	       	performOnUnLoad(destroyOperationsPage, "com_cisco_xmp_web_view_operations");

            var refreshAllDashboardTables = function(){
               setTimeout('refreshLogsTable(); refreshServersTable(); refreshDevicesTable()', refreshDashboardTableResizeDelay); 
            };

            var activateActiveDirectoryServerPassword = function()
            {
                var elem = dijit.byId("activeDirectoryServer.password");

                if (elem.disabled)
                {
                    elem.setDisabled(false);
                    elem.setValue("");
                    elem.focus();
                }
                else
                {
                    elem.setValue("<%=ItemBase.DEFAULT_PASSWORD_PHRASE%>");
                    elem.setDisabled(true);
                }
            };

            var activateNetworkDeviceSecret = function()
            {
                var elem = dijit.byId("networkDevice.secret");

                if (elem.disabled)
                {
                    dojo.query("#networkDeviceShowSecret").removeClass("hideit");
                    elem.setDisabled(false);
                    elem.setValue("");
                    elem.focus();
                }
                else
                {
                    dijit.byId("showsecret").setChecked(false);
                    changeSecretInput();                     
                    dojo.query("#networkDeviceShowSecret").addClass("hideit");
                    elem.setValue("<%=ItemBase.DEFAULT_PASSWORD_PHRASE%>");
                    elem.setDisabled(true);
                }
            };
        </script>
    </head>
    
    <body class="reboot2">
    <div dojotype="dijit.layout.BorderContainer" gutters="true">
        <div dojoType="dijit.layout.ContentPane">
            <table class="operations" cellspacing="0" cellpadding="0" style="width: 100%;">
                    <tr>
                        <td class="left"></td>
                        <td>
                            <div class="operationWrapper">
                                <a id="addServer" href="javascript:;" onClick="javascript: activeDirectoryServerAction('add');">
                                    <div class="opTitle"><h3>Add Active Directory Server</h3></div>
                                    <div style="background: url(../img/database_n_shadow_48x63.png) top no-repeat;" class="iconStatusWrapper">&nbsp;</div>
                                </a>
                                <div id="activeDirectoryServers" style="height: 20px;"><img src="../img/ajax-loader.gif"/></div>
                                <div class="agentOpsVSeparator"></div>
                                <div class="agentOperations">
                                    <div><img class="operationSmallIcon" src="../img/configure_n_16.png"/><a class="agentRunning" onClick="getAgentStatus(); showDialogAddContextHelp('agentDialog', 'ad_gnrl_stng');" href="javascript:;">Active Directory General Settings</a></div>
                               </div>
                           </div>
                        </td>
                        <td class="arrow"></td>
                        <td class="left"></td>
                        <td>
                            <div class="operationWrapper">
                                <a id="addConsumerDevice" href="javascript:;" onClick="javascript: netDevListAction('add');">
                                    <div class="opTitle"><h3>Add Consumer Device(s)</h3></div>
                                    <div class="iconStatusWrapper" style="background: url(../img/network_device_shadow_n_48x63.png) top no-repeat;">&nbsp;</div>
                                </a>
                                <div id="consumerDevices" style="height: 20px;"><img src="../img/ajax-loader.gif"/></div>
                                <div class="agentOpsVSeparator showOnPageLoad hideit"></div>
                                <div class="agentOperations showOnPageLoad hideit">
                                    <div><img class="operationSmallIcon" src="../img/cisco-asa-routing.jpg"/><a class="agentRunning" href="../index.html#pageId=com_cisco_xmp_web_page_consumer_devices">View Registered Devices</a></div>
                               </div>
                            </div>
                        </td>
                        <td class="arrow"></td>
                        <td class="left"></td>
                        <td>
                            <div class="operationWrapper">
                                <a id="addLogServer" href="javascript:;" onClick="javascript: syslogServerAction('add');">
                                    <div class="opTitle"><h3>Add Syslog Server (Optional)</h3></div>
                                    <div class="iconStatusWrapper" style="background: url(../img/syslog_shadow_n_48x63.png) top no-repeat;">&nbsp;</div>
                                </a>
                                <div id="syslogServers" style="height: 20px;"><img src="../img/ajax-loader.gif"/></div>
                                <div class="agentOpsVSeparator"></div>
                                <div class="agentOperations">
                                    <div><img class="operationSmallIcon" src="../img/configure_n_16.png"/><a class="agentRunning" onClick="getAgentStatus(); showDialogAddContextHelp('globalDialog', 'log_lvl_setng');" href="javascript:;">Log Level Settings</a></div>
                               </div>
                            </div>
                        </td>
                        <td></td>
                </table>
                <div style="height: 7px; background: none;"></div>
            </div>
        </div>

		<div dojoType="xwt.widget.layout.Dialog" title="Active Directory General Settings" class="xwtNotification" id="agentDialog" bgColor="black" bgOpacity="0.5" toggle="fade" toggleDuration="250" closeNode="hider">
			<form name="agentForm" action="agentAction.do?command=save" method="post" dojoAttachPoint="agentForm" id="agentForm" dojoType="xwt.widget.notification.Form">
		        <table>
		        	<tr>
		        		<td colspan="3" class="tdPaddingVertical">Time Intervals</td>
					</tr>
					<tr>
                        <td class="tdleft">
							<label for="agentConfig.monitoring"><span class="labelRequired">*</span>AD Monitoring</label>
						</td>
						<td>
							<input style="width: 2em;" id="agentConfig.monitoring" name="agentConfig.monitoring" tooltipPosition="top" type="text" dojoType="dijit.form.ValidationTextBox" required="true" regExp="[5-9]|[1-9][0-9]" invalidMessage="Should be a number (5-99)"/>
						</td>
                        <td class="tdright">seconds</td>
					</tr>
					<tr>
						<td class="tdleft">
							<label for="agentConfig.history"><span class="labelRequired">*</span>History</label>
						</td>
						<td>
							<input style="width: 2em;" id="agentConfig.history" name="agentConfig.history" tooltipPosition="top" type="text" dojoType="dijit.form.ValidationTextBox" required="true" regExp="[1-9]|[1-9][0-9]" invalidMessage="Should be a number (1-99)"/>
						</td>
                        <td class="tdright">minutes</td>
					</tr>
					<tr>
						<td class="tdleft">
							<label for="agentConfig.userLogonTtl"><span class="labelRequired">*</span>User logon expiration period</label>
						</td>
						<td>
                            <input dojoType="dijit.form.ValidationTextBox" id="agentConfig.userLogonTtl" jsId="agentConfig.userLogonTtl" name="agentConfig.userLogonTtl" tooltipPosition="top" type="text" required="true" regExp="[1-9]|1[0-9]|2[0-4]" invalidMessage="Should be a number (1-24)" style="width: 2em;">
						</td>
                        <td class="tdright">hours</td>
					</tr>
					<tr>
						<td class="tdleft">
							<label for="agentConfig.NTLMv2">Use NTLMv2 protocol</label>
						</td>
						<td>
                            <input dojoType="dijit.form.CheckBox" id="agentConfig.NTLMv2" jsId="agentConfig.NTLMv2" name="agentConfig.NTLMv2">
						</td>
                        <td class="tdright">&nbsp;</td>
					</tr>
					<tr>
						<td class="buttonstd" colspan="3">
	                        <button dojoType="xwt.widget.form.TextButton" type="submit">
	                            Save
	                        </button>
	                        <button dojoType="xwt.widget.form.TextButton" type="button" onClick="dijit.byId('agentDialog').hide();">
	                            Cancel
	                        </button>
						</td>
					</tr>			
				</table>
			</form>
		</div>

		<div dojoType="xwt.widget.layout.Dialog" title="Global Log Level Settings" class="xwtNotification" id="globalDialog" bgColor="black" bgOpacity="0.5" toggle="fade" toggleDuration="250" closeNode="hider">
			<form name="globalForm" action="agentAction.do?command=save" method="post" dojoAttachPoint="globalForm" id="globalForm" dojoType="xwt.widget.notification.Form">
		        <table>
					<tr>
						<td class="tdleft">
							<label for="agentConfig.level">Log level</label>
						</td>
						<td>
					        <select name="agentConfig.level" id="agentConfig.level" dojoType="dijit.form.Select" style="width: 12em;">
                                <option value="FATAL">FATAL</option>
                                <option value="ERROR">ERROR</option>
                                <option value="WARNING">WARNING</option>
					            <option value="NOTICE" selected="selected">NOTICE</option>
                                <option value="INFO">INFO</option>
                                <option value="DEBUG">DEBUG</option>                                
				       		</select>
						</td>
					</tr>
					<tr>
						<td class="buttonstd" colspan="2">
	                        <button dojoType="xwt.widget.form.TextButton" type="submit">
	                            Save
	                        </button>
	                        <button dojoType="xwt.widget.form.TextButton" type="button" onClick="dijit.byId('globalDialog').hide();">
	                            Cancel
	                        </button>
						</td>
					</tr>
				</table>
			</form>
		</div>
		
		<div dojoType="xwt.widget.layout.Dialog" title="Active Directory Server Configuration" class="xwtNotification" id="serverDialog" bgColor="black" bgOpacity="0.5" toggle="fade" toggleDuration="100" closeNode="hider">
			<form name="serverForm" action="serversAction.do?command=save" method="post" dojoAttachPoint="serverForm" id="serverForm" dojoType="xwt.widget.notification.Form">
		        <input type="hidden" name="serverToEdit" id="serverToEdit" value=""/>
		        <table>
		        	
		        	<tr>
		        		<td colspan="2" class="tdPaddingVertical">General Settings</td>
					</tr>
					<tr>
						<td class="tdleft">
							<label for="activeDirectoryServer.name"><span class="labelRequired">*</span>Display Name</label>
						</td>
						<td class="tdright">
							<input id="activeDirectoryServer.name" name="activeDirectoryServer.name" tooltipPosition="top" type="text" required="true" trim="true"  dojoType="xwt.widget.notification.ValidationTextBox" maxLength="<%=ItemBase.MAX_ITEM_MEMBER_LENGTH%>"/>
						</td>
					</tr>
					<tr>
						<td class="tdleft">
							<label for="activeDirectoryServer.domain"><span class="labelRequired">*</span>Domain FQDN</label>
						</td>
						<td class="tdright">
							<input id="activeDirectoryServer.domain" name="activeDirectoryServer.domain" tooltipPosition="top" type="text" required="true" trim="true"  dojoType="xwt.widget.notification.ValidationTextBox" maxLength="<%=ItemBase.MAX_ITEM_MEMBER_LENGTH%>"/>
						</td>
					</tr>
					<tr>
                        <td class="tdleft">
							<label for="activeDirectoryServer.host"><span class="labelRequired">*</span>Host FQDN</label>
						</td>
						<td class="tdright">
							<input id="activeDirectoryServer.host" name="activeDirectoryServer.host" tooltipPosition="top" type="text" required="true" trim="true"  dojoType="xwt.widget.notification.ValidationTextBox" maxLength="<%=ItemBase.MAX_ITEM_MEMBER_LENGTH%>"/>
						</td>
					</tr>					
		        	<tr>
		        		<td colspan="2" class="tdPaddingVertical">Administrator</td>
					</tr>
					<tr>
                        <td class="tdleft">
							<label for="activeDirectoryServer.username"><span class="labelRequired">*</span>Username</label>
						</td>
						<td class="tdright">
							<input id="activeDirectoryServer.username" name="activeDirectoryServer.username" tooltipPosition="top" type="text" required="true" trim="true"  dojoType="xwt.widget.notification.ValidationTextBox" maxLength="<%=ItemBase.MAX_ITEM_MEMBER_LENGTH%>"/>
						</td>
					</tr>
					<tr id="activeDirectoryServerPassword" class="hideit">
                        <td class="tdleft">
							<input checked="false" id="activeDirectoryServer.changePassword" dojoType="dijit.form.CheckBox" name="activeDirectoryServer.changePassword" type="checkbox" onClick="activateActiveDirectoryServerPassword();"/>
						</td>
						<td class="tdright">
							<label for="activeDirectoryServer.changePassword">Change password</label>
						</td>
					</tr>
					<tr>
                        <td class="tdleft">
							<label for="activeDirectoryServer.password"><span class="labelRequired">*</span>Password</label>
						</td>
						<td class="tdright">
							<input id="activeDirectoryServer.password" name="activeDirectoryServer.password" tooltipPosition="top" type="password" required="true" trim="true"  dojoType="xwt.widget.notification.ValidationTextBox" maxLength="<%=ItemBase.MAX_ITEM_MEMBER_LENGTH%>"/>
						</td>
					</tr>
					<tr>
                        <td colspan="2" style="font-size: 10px; padding-top:10px;">
                            <div style="width: 270px;"><b>Supported OS's</b>: Windows 2003, Windows 2003 R2, Windows 2008, Windows 2008 R2, Windows 2012</div>
                        </td>
					</tr>
					<tr>
						<td class="buttonstd" colspan="2">
	                        <button dojoType="xwt.widget.form.TextButton" type="submit">
	                            Save
	                        </button>
	                        <button dojoType="xwt.widget.form.TextButton" type="button" onClick="dijit.byId('serverDialog').hide();">
	                            Cancel
	                        </button>
						</td>
					</tr>			
				</table>
			</form>
		</div>		
		
		<div dojoType="xwt.widget.layout.Dialog" title="Identity Consumer Configuration" class="xwtNotification" id="consumerDialog" bgColor="black" bgOpacity="0.5" toggle="fade" toggleDuration="100" closeNode="hider">
			<form name="consumerForm" action="devicesAction.do?command=save" method="post" dojoAttachPoint="consumerForm" id="consumerForm" dojoType="xwt.widget.notification.Form">
				<input type="hidden" name="deviceToEdit" id="deviceToEdit" value=""/>
		        <table>
					<tr>
                        <td class="tdleft">
							<label for="networkDevice.name"><span class="labelRequired">*</span>Name</label>
						</td>
						<td class="tdright">
							<input id="networkDevice.name" name="networkDevice.name" tooltipPosition="top" type="text" required="true" trim="true"  dojoType="xwt.widget.notification.ValidationTextBox" maxLength="<%=ItemBase.MAX_ITEM_MEMBER_LENGTH%>"/>
						</td>
					</tr>
					<tr>
                        <td class="tdleft">
							<label for="networkDevice.ip"><span class="labelRequired">*</span>IP Address</label>
						</td>
						<td class="tdright">
							<input dojoType="xwt.widget.form.IPv4TextBox" id="networkDevice.ip" jsId="networkDevice.ip" name="networkDevice.ip" tooltipPosition="top" type="text" required="true"/><!-- invalidMessage="Have to provide IP" -->
						</td>
					</tr>
					<tr>
                        <td class="tdleft">
							<label for="networkDevice.mask">Mask (range)</label>
						</td>
						<td class="tdright">
							<input dojoType="dijit.form.NumberTextBox" id="networkDevice.mask" jsId="networkDevice.mask" name="networkDevice.mask" tooltipPosition="top" type="text" constraints="{min:0,max:32,places:0}" invalidMessage="Should be a number (0-32)" style="width: 2em;">
						</td>
					</tr>
					<tr id="networkDeviceSecret" class="hideit">
                        <td class="tdleft">
							<input checked="false" id="networkDevice.changeSecret" dojoType="dijit.form.CheckBox" name="networkDevice.changeSecret" type="checkbox" onClick="activateNetworkDeviceSecret();"/>
						</td>
						<td class="tdright">
							<label for="networkDevice.changeSecret">Change secret</label>
						</td>
					</tr>
					<tr>
                        <td class="tdleft">
							<label for="networkDevice.secret"><span class="labelRequired">*</span>Shared secret&nbsp;</label>
						</td>
						<td class="tdright">
							<input id="networkDevice.secret" jsId="networkDevice.secret" name="networkDevice.secret" tooltipPosition="top" type="password" required="true" trim="true"  dojoType="xwt.widget.notification.ValidationTextBox" maxLength="<%=2*ItemBase.MAX_ITEM_MEMBER_LENGTH%>"/>
						</td>
					</tr>
					<tr id="networkDeviceShowSecret">
                        <td class="tdleft">
							<input id="showsecret" jsId="showsecret" dojoType="dijit.form.CheckBox" name="showsecret" type="checkbox" onClick="changeSecretInput();"/>
						</td>
						<td class="tdright">
							<label>Show secret</label>
						</td>
					</tr>
					<tr>
						<td class="buttonstd" colspan="2">
	                        <button dojoType="xwt.widget.form.TextButton" type="submit">
	                            Save
	                        </button>
	                        <button dojoType="xwt.widget.form.TextButton" type="button" onClick="dijit.byId('consumerDialog').hide();">
	                            Cancel
	                        </button>
						</td>
					</tr>			
				</table>
			</form>
		</div>				

		<div dojoType="xwt.widget.layout.Dialog" title="Syslog Server Configuration" class="xwtNotification" id="syslogDialog" bgColor="black" bgOpacity="0.5" toggle="fade" toggleDuration="100" closeNode="hider">
			<form name="syslogForm" action="logsAction.do?command=save" method="post" dojoAttachPoint="syslogForm" id="syslogForm" dojoType="xwt.widget.notification.Form">
		        <input type="hidden" name="syslogServerToEdit" id="syslogServerToEdit" value=""/>
		        <table>
					<tr>
                        <td class="tdleft">
							<label for="syslogServer.name"><span class="labelRequired">*</span>Display Name</label>
						</td>
						<td class="tdright">
							<input id="syslogServer.name" name="syslogServer.name" tooltipPosition="top" type="text" required="true" trim="true"  dojoType="xwt.widget.notification.ValidationTextBox" maxLength="<%=ItemBase.MAX_ITEM_MEMBER_LENGTH%>"/>
						</td>
					</tr>
					<tr>
                        <td class="tdleft">
							<label for="syslogServer.logIp"><span class="labelRequired">*</span>IP Address</label>
						</td>
						<td class="tdright">
							<input dojoType="xwt.widget.form.IPv4TextBox" id="syslogServer.logIp" jsId="syslogServer.logIp" name="syslogServer.logIp" tooltipPosition="top" type="text" required="true"/><!-- invalidMessage="Have to provide IP" -->
						</td>
					</tr>
					<tr>
						<td class="tdleft">
							<label for="syslogServer.facility">Facility</label>
						</td>
						<td class="tdright">
					        <select name="syslogServer.facility" id="syslogServer.facility" dojoType="dijit.form.Select" style="width: 12em;" tooltipPosition="top" required="true" invalidMessage="Have to provide facility">
					            <option value="local0">local0</option>
                                <option value="local1">local1</option>
                                <option value="local2">local2</option>
                                <option value="local3">local3</option>
                                <option value="local4">local4</option>
                                <option value="local5">local5</option>
                                <option value="local6">local6</option>
                                <option value="local7">local7</option>
				       		</select>                            
						</td>
					</tr>					
					<tr>
						<td class="buttonstd" colspan="2">
	                        <button dojoType="xwt.widget.form.TextButton" type="submit">
	                            Save
	                        </button>
	                        <button dojoType="xwt.widget.form.TextButton" type="button" onClick="dijit.byId('syslogDialog').hide();">
	                            Cancel
	                        </button>
						</td>
					</tr>			
				</table>
			</form>
		</div>
    </body>
</html>
