#!/bin/sh
###########################################################################
#     Filename: cdaversion.sh
#  Description: Script to output CDA version
#        Usage: $0 [ start | stop | status ] called by CARS CLI 
#       Author: alhino@cisco.com
#
# Copyright (c) 2009-2012 Cisco Systems, Inc.  This program contains
# proprietary and confidential information.  All rights reserved
# except as may be permitted by prior written consent.
###########################################################################

VER=`rpm -q --queryformat "%{VERSION}.%{RELEASE}\n" CSCOcda`
BDATE=`rpm -qi CSCOcda |grep "Build Date:" |sed "s/^.*Build Date: //"`
IDATE=`rpm -qi CSCOcda |grep "Install Date:" |sed "s/Install Date: \(.*\)    Build Host.*$/\1/"`

echo "Cisco Context Directory Agent"
echo "---------------------------------------------"
echo "Version      : $VER"
echo "Build Date   : $BDATE"
echo "Install Date : $IDATE"
echo ""


for i in `ls -v  /storeddata/Manifest/cda`
 do
   if [ -d /storeddata/Manifest/cda/$i ] && [ -f /storeddata/Manifest/cda/$i/manifest.xml ]
    then
       echo "Cisco Context Directory Agent Patch "
       echo "---------------------------------------------"
        PIDATE=`ls -ld --time-style="+%a %b %d %H:%M:%S %Y" /storeddata/Manifest/cda/$i | awk -F" " {'print $6" " $7 " " $8 " " $9" " $10'}`
        echo "Version      : $i"
        echo -n "Build number : "
        if [ -f /storeddata/Installed/cda/$i/backup/patchbuildversion ] ; then
          cat "/storeddata/Installed/cda/$i/backup/patchbuildversion"
        else
          echo "NA"
        fi
        echo "Install Date : $PIDATE"
        echo ""
   fi
 done
